<link rel="import" href="../../bower_components/polymer/polymer-element.html">

<link rel="import" href="../../bower_components/dez-export-button/dez-export-button.html">
<link rel="import" href="../../bower_components/dez-analyses-dropdown/dez-analyses-dropdown.html">
<link rel="import" href="../../bower_components/dez-collab/dez-collab.html">
<link rel="import" href="../../bower_components/dez-open-file-button/dez-open-file-button.html">

<script src="../../bower_components/file-saver/dist/FileSaver.js"></script>

<link rel="import" href="dez-save-analysis-button.html">
<link rel="import" href="dez-save-file-button.html">
<link rel="import" href="dez-collab-mode-btn.html">

<dom-module id="dez-analysis-controls">
  <template>
    <style>
    </style>

    <dez-analyses-dropdown
      id="analysesDropdown"
      analyses="[[_analysesNames]]">
    </dez-analyses-dropdown>

    <dez-save-analysis-button
      id="saveAnalysisButton"
      analyses-location="[[location]]"
      selected-analysis="[[selectedAnalysis]]"
      analysis-files="{{files}}"
      analyses-names="{{_analysesNames}}">
    </dez-save-analysis-button>

    <dez-open-file-button
      id="dezInput"
      class="hidden-xs"
      on-tap="_onOpenFileTap"
      on-file-loaded="_loadNewAnalysis">
    </dez-open-file-button>

    <dez-save-file-button on-save-button-tap="_onSaveButtonTap"></dez-save-file-button>

    <dez-export-button
      id="exportButton"
      class="hidden-xs"
      export-data="[[_exportData]]">
    </dez-export-button>

    <template is="dom-if" if="[[collabOn]]" on-dom-change="_initCollab">
      <dez-collab-mode-btn id="collabModeBtn"></dez-collab-mode-btn>
      <dez-collab id="collab"></dez-collab>
    </template>

    <iron-ajax
        url="[[location]]"
        handle-as="json"
        debounce-duration="300"
        auto
        on-response="_analysesReady">
    </iron-ajax>

  </template>

  <script>

  class DezAnalysisControls extends Polymer.Element {

      static get is() { return 'dez-analysis-controls'; }

      static get properties() {
        return {
          files: {
            type: Array,
            observer: "_filesHaveChanged"
          },
          collabOn : {
            type : Boolean,
            value : false
          },
          pieceId: String,
          pieceName: String,
          location: String
        };
      }

      _filesHaveChanged () {
        this._analysesNames = this.files.map(a => a.name);
      }

      set confirmDialog (element) {
        this._confirmDialog = element
        this._confirmDialog.addEventListener(
          'action-confirmed',
          event => this._confirmAction()
        )
      }

      ready () {
        super.ready()
        Polymer.Gestures.addListener(
          this.$.exportButton,
          'tap',
          e => this._exportData = this._analysis.toJson()
        )
        this.$.analysesDropdown.addEventListener(
            'new-analysis-selected',
            e => {
                this._wantedAnalysisName = e.detail.name;
                this._actionToConfirm = "CHANGE_ANALYSIS"
                if (this._analysis.backupNeeded) { // first selection (first load)
                    this._confirmDialog.open();
                } else {
                    this._changeAnalysis();
                }
            }
        );
        this.$.saveAnalysisButton.dropdown = this.$.analysesDropdown
      }

      set analysis (analysis) {
        this._analysis = analysis
        this.$.saveAnalysisButton.analysis = this._analysis
      }

      async _changeAnalysis () {
        if (this._wantedAnalysisName) {
          this.selectedAnalysis = this._wantedAnalysisName;
          let file = this.files.filter(a => a.name == this._wantedAnalysisName)[0]
          if (file != undefined) {
            await this._analysis.loadAnalysisFrom(file.location)
            this._analysis.updateMeta({
              'title': this.pieceName,
              'name': this.selectedAnalysis
            })
            this.$.analysesDropdown.confirmSelected();
          }
        }
      }

      _confirmAction () {
          if (this._actionToConfirm == "CHANGE_ANALYSIS") {
              this._changeAnalysis ();
            } else if (this._actionToConfirm == "LOAD_LOCAL_DEZ") {
              this.$.dezInput.openDialog()
          }
          this._analysis.backupNeeded = false;
      }

      /*
      FILE INPUT
       */
      _onOpenFileTap () {
        if (this._analysis.backupNeeded) {
          this._actionToConfirm = "LOAD_LOCAL_DEZ"
          this._confirmDialog.open();
        } else {
          this.$.dezInput.openDialog()
        }
      }

      _onSaveButtonTap (event) {
        let data = ""
        let format = event.detail.format
        if (format == "csv") {
          data = this._analysis.toCSV()
        } else if (format == "dez") {
          data = this._analysis.toJson()
        }
        window.saveAs(
          new Blob(
            [data],
            {type: "text/plain;charset=utf-8"}
          ),
          this.pieceId + "." + format
        )
      }

      _loadNewAnalysis (event) {
        this._analysis.erase()
        let re = /(.*[^.]+)[.](.*)$/
        let match = re.exec(event.detail.name)
        let analysisName = match[1]
        let format = match[2]
        this._analysis.updateMeta({
          'title': this.pieceName,
          'name': analysisName
        })
        if (format == "dez") {
          this._analysis.loadJson(event.detail.content)
        } else if (format == "csv") {
          this._analysis.loadCSV(event.detail.content)
        } else {
          console.log('Format error!');
        }
        this.selectedAnalysis = analysisName
        this.$.analysesDropdown.name = this.selectedAnalysis + " *"
      }
      /*
      FILE INPUT END
       */

       _analysesReady (event) {
         this.files = event.detail.response.map(name => {
           return {
             "name": name.split(".dez")[0],
             "location": this.location + "/" + name
           }
         });
       }

       _initCollab () {
         let collabModeBtn = this.shadowRoot.querySelector('#collabModeBtn')
         let collab = this.shadowRoot.querySelector('#collab')
         collabModeBtn.addEventListener('collab-mode-on', event => {
           collab.analysis = this._analysis
           collab.enable()
         })
         collabModeBtn.addEventListener('collab-mode-off', event => {
           collab.disable()
           location.reload()
         })
         collab.addEventListener('client-disconnected', e => {
           let r = confirm("Are you going to use disconnect Mode?")
           if(r == false){
             location.reload()
           } else {
             console.log("disconnect mode")
           }
         })
       }


  }

  window.customElements.define(DezAnalysisControls.is, DezAnalysisControls);

  </script>
</dom-module>
